<template lang="pug">
  div.discord.container
    el-row(justify="center" align="middle" type="flex")
      h1 #[span.highlight Coco]: The Auto-Gallery
    el-row(justify="center" align="middle" type="flex")
      el-row.login.card(justify="center" type="flex")
        el-card
          el-row(justify="center" align="middle" type="flex")
            h2 #[i.bx.bx-book] {{pair ? pair.name : ''}} History
          div(v-if="user && pair && tracks && !loading")
            el-row(justify="center" type="flex")
              el-row(justify="center" align="middle" type="flex")
                el-avatar(:src="getAvatar(user)")
                el-tag(type="primary") {{user.username}}\#{{user.discriminator}}
            el-divider History
            el-row(justify="center" align="middle" type="flex")
              p You can find a history of the last 100 posts sent in this pair here, from newest to oldest.
            el-row(justify="center" type="block" v-for="track in tracks" :key="track.timestamp")
              el-card
                el-row(justify="left" type="flex")
                  el-row
                    el-card
                      a(:href="track.post.file" target="__blank")
                        el-image.small.blurred.image(v-if="isNSFW(track.post)" :src="getImage(track.post)" fit="cover")
                        el-image.small.image(v-else :src="getImage(track.post)" fit="cover")
                  el-row
                    el-row
                      el-divider(direction="vertical")
                      span {{track.service.toUpperCase()}} #[a(:href="track.post.url" target="__blank") #[span #[el-tag \#{{track.post.id}}]]]
                    el-row
                      el-divider(direction="vertical")
                      span Rating: #[el-tag(:type="getRatingType(track.post.rating)") {{getRatingName(track.post.rating)}}]
                    el-row
                      el-divider(direction="vertical")
                      span Hash: #[el-tag {{track.post.md5}}]
                    el-row
                      el-divider(direction="vertical")
                      span(v-if="track.post.tags.length !== 0") Tags: #[el-tag(v-for="tag in track.post.tags" :key="tag" :type="isTagNSFW(tag) ? 'danger' : 'success'") {{tag}}]
                      span(v-else-if="track.service === 'reddit'") Subreddit: #[el-tag() {{track.post.source_name}}]
                    el-row
                      el-divider(direction="vertical")
                      span Sent: {{localTime(track.timestamp)}}
          div(v-else-if="loading")
            el-row(justify="center" align="middle" type="flex")
              p #[i.bx.bx-spa] Loading...
            el-row(justify="center"  type="flex")
              p(v-loading="loading" element-loading-background="rgba(255, 255, 255, 0.75)") {{quote}}
            el-row(justify="center" type="flex")
              p Please wait while we fetch all post records...
          div(v-else)
            el-row(justify="center" align="middle" type="flex")
              p #[i.bx.bx-ghost] You aren't supposed to be here, it seems.
            el-divider Please...
            el-row(justify="center" type="flex")
              NuxtLink(to="/") #[el-button(type="primary") #[i.bx.bx-home] Go Home]
          el-divider(v-if="user && pair && tracks && tags && !loading")
          el-row(v-if="user && pair && tracks && tags && !loading" justify="center" type="flex")
            NuxtLink(to="/dashboard") #[el-button(type="primary") #[i.bx.bxs-dashboard] Dashboard]
</template>

<script lang="ts">
import Vue from 'vue'

import Easter from '@/middleware/easter'

const easter = new Easter()

function getQuote () {
  const quoter = easter.pick()
  let text = quoter.quotes[Math.floor(Math.random() * quoter.quotes.length)]
  text = `${quoter.icon} ${text}`
  return text
}

async function getTracks (token: string, id: string) {
  const api = `/api/v1/tracks/${id}`
  const resp = await fetch(api, {
    method: 'GET',
    headers: {
      Authorization: token
    }
  })
  return resp
}

async function getUser (token: string) {
  const api = '/api/v1/user'
  return await fetch(api, {
    method: 'GET',
    headers: {
      Authorization: token
    }
  })
}

async function getPair (token: string, id: string) {
  const api = `/api/v1/pair/${id}`
  const resp = await fetch(api, {
    method: 'GET',
    headers: {
      Authorization: token
    }
  })
  return resp
}

export default Vue.extend({
  data () {
    return {
      tracks: null,
      user: null,
      pair: null,
      token: window.localStorage.getItem('coco_token'),
      quote: getQuote(),
      loading: true,
      processing: false,
      toDelete: null as any
    }
  },
  async mounted () {
    if (typeof (this.token) === 'string') {
      const user = await getUser(this.token)
      this.user = await user.json()
      const tracks = await getTracks(this.token, this.$route.query.id as string)
      this.tracks = await tracks.json()
      const pair = await getPair(this.token, this.$route.query.id as string)
      this.pair = await pair.json()
      this.loading = false
    }
  },
  methods: {
    getAvatar (user: any): string | null {
      const ext = user.avatar.indexOf('a_') === 0 ? 'gif' : 'png'
      return `https://cdn.discordapp.com/avatars/${user.id}/${user.avatar}.${ext}`
    },
    localTime (stamp: number): string {
      const dt = new Date(stamp * 1000)
      return dt.toLocaleString()
    },
    tagType (msg: string): string {
      if (msg === 'created') {
        return 'success'
      } else if (msg === 'edited') {
        return 'warning'
      } else {
        return 'default'
      }
    },
    areTagsNSFW (tags: string[]): boolean {
      const ctx = this
      let nsfw = false
      tags.forEach((tag) => {
        if (ctx.isTagNSFW(tag)) {
          nsfw = true
        }
      })
      return nsfw
    },
    isTagNSFW (tag: string): boolean {
      if (this.pair !== null) {
        return (this.pair as any).settings.tags.nsfw.includes(tag)
      } else {
        return false
      }
    },
    isNSFW (post: any): boolean {
      if (post.rating === 0) {
        return false
      } else if (post.rating === 1) {
        return this.areTagsNSFW(post.tags)
      } else if (post.rating === 2) {
        return true
      }
      return true
    },
    getRatingName (rating: number): string {
      if (rating === 0) {
        return 'Safe'
      } else if (rating === 1) {
        return 'Questionable'
      } else if (rating === 2) {
        return 'Explicit'
      } else {
        return 'Unknown'
      }
    },
    getRatingType (rating: number): string {
      if (rating === 0) {
        return 'success'
      } else if (rating === 1) {
        return 'warning'
      } else if (rating === 2) {
        return 'danger'
      } else {
        return 'warning'
      }
    },
    getImageDir (hash: string): string {
      return `${hash[0]}${hash[1]}/${hash[2]}${hash[3]}`
    },
    getImage (post: any): string {
      if (post.source === 'yandere') {
        return `https://assets.yande.re/data/preview/${this.getImageDir(post.md5)}/${post.md5}.jpg`
      } else if (post.source === 'konachan') {
        return `https://konachan.com/data/preview/${this.getImageDir(post.md5)}/${post.md5}.jpg`
      } else {
        return post.file
      }
    }
  }
})
</script>

<style lang="scss" scoped>
.float.right {
  float: right;
}
.image {
  &.small {
    width: 110px;
    height: 110px;
  }
  &.blurred {
    filter: blur(5px);
  }
  &:hover {
    filter: unset;
  }
}
</style>
